"use strict";

Component({
  mixins: [],
  data: {
    $uiName: 'list-item',
    selected: false
  },
  props: {
    className: '',
    captionClassName: '',
    // 控制标题样式
    dmId: '',
    disabled: false,
    //checkbox配置
    checkable: false,
    //是否显示checkbox
    checked: false,
    //默认选中状态
    //thumb
    thumbClassName: '',
    thumbSize: 'standard',
    // mini(48rpx)、standard(72rpx)、big(96rpx)、large(112rpx)
    thumbType: 'circle',
    //circle、square
    thumbUrl: '',
    thumbVTop: false,
    thumbContent: '',
    // thumbUrl为空时，用thumbContent拼接头像
    //extra
    extraClassName: '',
    extraVTop: false,
    extraText: '',
    //badge
    badgeShow: false,
    badgeText: '',
    // arrow，查看wings-icon
    arrowClassName: '',
    arrowType: '',
    //icon的type
    arrowSize: 'small',
    //查看wings-icon的size
    briefClassName: '',
    briefList: [],
    //border-bottom
    hasborder: false,
    //强制设置border
    noborder: false,
    //强制隐藏border
    onDmTap: function onDmTap() {},
    onDmChange: function onDmChange() {},
    onDmArrowClick: null
  },
  didMount: function didMount() {
    var checked = this.props.checked;
    this.setData({
      selected: checked
    });
  },
  didUpdate: function didUpdate(preProps) {
    var checked = this.props.checked;

    if (preProps.checked !== checked) {
      this.setData({
        selected: checked
      });
    }
  },
  didUnmount: function didUnmount() {},
  methods: {
    handleCheckboxChange: function handleCheckboxChange(e) {
      var _this$props = this.props,
          onDmChange = _this$props.onDmChange,
          dmId = _this$props.dmId;
      var selected = this.data.selected;
      this.setData({
        selected: !selected
      });
      onDmChange({
        dmId: dmId,
        status: !selected
      }, e, this);
    },
    // handleArrowTap(e) {
    //   const { dataset } = e.target;
    //   const { dmId } = dataset;
    //   const { onDmArrowClick } = this.props;
    //   onDmArrowClick(dmId,e,this);
    // },
    onDmTap: function onDmTap(e) {
      var dataset = e.target.dataset;
      var dmId = dataset.dmId,
          type = dataset.type;
      var _this$props2 = this.props,
          onDmTap = _this$props2.onDmTap,
          onDmArrowClick = _this$props2.onDmArrowClick,
          checkable = _this$props2.checkable,
          disabled = _this$props2.disabled;

      if (type == 'arrow' && onDmArrowClick) {
        onDmArrowClick(dmId, e, this);
      } else {
        if (checkable && !disabled) {
          this.handleCheckboxChange(e);
        }

        onDmTap(dmId, e, this);
      }
    }
  }
});