"use strict";

Component({
  mixins: [],
  data: {
    $uiName: 'message',
    $cssName: 'dm-message',
    show: false
  },
  props: {
    className: '',
    visible: false,
    animate: false,
    content: '',
    duration: 2000,
    type: 'success',
    // 'success' || 'warning' || 'error'
    onDmMessageHide: function onDmMessageHide() {}
  },
  didMount: function didMount() {
    if (this.props.visible) {
      this.init();
    }
  },
  didUpdate: function didUpdate(prevProps, prevData) {
    if (this.props.visible) {
      this.init();
    }
  },
  methods: {
    clearTimer: function clearTimer() {
      if (this.timer) {
        clearTimeout(this.timer);
      }
    },
    showMessage: function showMessage() {
      this.setData({
        text: this.props.content,
        show: true,
        animate: true
      });
    },
    hideMessage: function hideMessage() {
      var _this = this;

      this.setData({
        show: false
      }, function () {
        _this.props.onDmMessageHide();
      });
    },
    init: function init() {
      var _this2 = this;

      var duration = this.props.duration;
      this.clearTimer();
      this.showMessage();
      this.timer = setTimeout(function () {
        _this2.hideMessage();
      }, duration);
    }
  }
});